/* This is dhtmem.c --  Version 1.2
 * This code is copyright by
 *	Elmar Bartel 1993,
 *	Institut fuer Informatik, TU Muenchen, Germany  
 *	bartel@informatik.tu-muenchen.de
 * You may use this code as you wish, as long as this
 * comment with the above copyright notice is keept intact
 * and in place.
 */

#include <stdio.h>
#include "dhtvalue.h"
#include "dhtmem.h"


#define ConvertPrime	37

typedef unsigned long uLong;
typedef unsigned char uChar;

static unsigned long HashMemoryValue(dhtValue v) {
	uLong h= ConvertPrime;
	uLong leng= ((MemVal*)v)->Leng; 
	uChar *s= ((MemVal*)v)->Data;
	while (0< leng--)
		h = (h * ConvertPrime) ^ (*s++ - ' ');
 	return h;
}
static int EqualMemoryValue(dhtValue v1, dhtValue v2) {
	if (((MemVal*)v1)->Leng != ((MemVal*)v2)->Leng)
		return 0;
	if (memcmp(((MemVal*)v1)->Data, ((MemVal*)v2)->Data, ((MemVal*)v1)->Leng))
		return 0;
	else
		return 1;
}

extern	dhtStatus	dhtDupStatus;

static dhtValue	DupMemoryValue(dhtValue v) {
	MemVal *mv;
	dhtDupStatus= dhtOkStatus;
	if (mv=NewMemVal) {
		mv->Data= (unsigned char *)fxfAlloc(((MemVal*)v)->Leng);
		if (!mv->Data)
			FreeMemVal(mv);
		else {
			mv->Leng= ((MemVal*)v)->Leng;
			memcpy(mv->Data, ((MemVal*)v)->Data, mv->Leng);
			return (dhtValue)mv;
		}
	}
	dhtDupStatus= dhtFailedStatus;
	return (dhtValue)mv;
}
static void	FreeMemoryValue(dhtValue v) {
	DeleteMemVal(v);
	return;
}
static void	DumpMemoryValue(dhtValue v, FILE *f) {
	int i;
	fprintf(f, "(%d)", ((MemVal*)v)->Leng);
	for (i=0; i<((MemVal*)v)->Leng; i++)
		fprintf(f, "%02x", ((MemVal*)v)->Data[i] & 0xff);
	return;
}
dhtValueProcedures dhtMemoryProcs = {
	HashMemoryValue,
	EqualMemoryValue,
	DupMemoryValue,
	FreeMemoryValue,
	DumpMemoryValue
};
