/* This is dhtstring.c --  Version 1.2
 * This code is copyright by
 *	Elmar Bartel 1993,
 *	Institut fuer Informatik, TU Muenchen, Germany  
 *	bartel@informatik.tu-muenchen.de
 * You may use this code as you wish, as long as this
 * comment with the above copyright notice is keept intact
 * and in place.
 */
#include <stdio.h>
#include <string.h>
#include <stdlib.h>			/* for malloc() */
#include "dhtvalue.h"

#define ConvertPrime		37

/*
static unsigned long ConvertString(dhtValue v) {
	unsigned long h= ConvertPrime;
	char *s= (char *)v;
	while (*s)
		h = (h * ConvertPrime) ^ (*s++ - ' ');
 	return h;
}
*/
static unsigned long ConvertString(dhtValue v) {
	unsigned long h= ConvertPrime;
	char *s= (char *)v;
	while (*s)
		h^= (*s++ - ' ')*ConvertPrime;
 	return h;
}
static int EqualString(dhtValue v1, dhtValue v2) {
	if (strcmp((char *)v1, (char *)v2))
		return 0;
	else
		return 1;
}

extern	dhtStatus	dhtDupStatus;

static dhtValue	DupString(dhtValue v) {
	char *nv;
	nv= fxfAlloc(strlen((char *)v)+1);
	if (nv == (char *)0)
	    dhtDupStatus= dhtFailedStatus;
	else {
	    strcpy(nv, (char *)v);
	    dhtDupStatus= dhtOkStatus;
	}
	return (dhtValue)nv;
}
static void	FreeString(dhtValue v) {
	fxfFree(v, strlen((char *)v)+1);
	return;
}
static void	DumpString(dhtValue v, FILE *f) {
	fprintf(f, "%s", (char *)v);
	return;
}
dhtValueProcedures dhtStringProcs = {
	ConvertString,
	EqualString,
	DupString,
	FreeString,
	DumpString
};
