/**
 *	tbl_name.c	n.k.	may 28, 1993
 *	tb2_name.c	k.f.	july 29, 1996
 *
 *  char *tb2_name( tb2_Spec *tb2, int ser )
 *        -  get name from serial-number
 *    tb2 -  table spec returned from tb2_read()
 *    ser -  serial # for the name 
 *
 *  char *tbl_name( int ser )
 *        -  get name from serial-number
 *    ser - serial # for the name 
 *
 *  return:  pointer to name (char*) for specified serial number ser
 *  tb2_errno: n=0  -- successfully completed
 *             < 0  -- error (see tbl.h)
 *
 *  (cf.) int _tb2_num( tb2_Spec tb2, char* name )
 *        -  get serial number of name in the table
**/
static char what_tb2name[] =
"@(#)tb2_name.c, v2.0, n.f, k.f, table name-to-serial, jun.1992-oct.1996";

/*** definitions ***/
#include  "tb2.h"         /* error codes, default directory */

/**
 *   tb2_name() - get name from serial_number
**/
char *tb2_name( tb2, serial )
tb2_Spec *tb2;			/* table specification */
int   serial;			/* serial number */
{
    tb2_Entry *entry;			/* table entry */

    if ( !(tb2) )  goto EUNREAD;	/* if valid table spec. */

    if ( !(entry = tb2_entryfind( tb2, (char *)NULL, serial, 's' )) )
	goto ENONAME;

/*** [2] return ***/
    tb2_errno = 0;
    return (entry->name);		/* return pointer */

/*** errors ***/
 EUNREAD:
#ifdef TBL_WARN
    fprintf( WARN_DEST, 
          "tb2_name %s: table is not read yet\n", TBL_VER );
#endif
    tb2_errno = TBL_E_UNREAD;
    return (char *)NULL;

 ENONAME:
#ifdef TBL_WARN
    fprintf( WARN_DEST, 
	    "tbl_name %s: serial number='%d' is invalid for table='%s'\n", 
	    TBL_VER, serial, tb2->filename );
#endif
    tb2_errno = TBL_E_NONAME;
    return (char *)NULL;
}
/**
 *   tbl_name() - get name from serial_number
**/
char *tbl_name( serial )
int   serial;			/* serial number */
{
    return tb2_name(default_tbl, serial );
}
